package com.androidseminar.activitystatetest;

import android.app.Application;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {
    static int counter=0;
    static int statecounter=0;
    TextView v,d,s;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        v=(TextView)this.findViewById(R.id.textView3);
        v.setText("This is the start value");
        d=(TextView)this.findViewById(R.id.textView);
        s=(TextView)this.findViewById(R.id.textView2);
        d.setText("");
        if(savedInstanceState!=null)onRestoreInstanceState(savedInstanceState);
        addText("Debug", "onCreate");

    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
      /*  outState.putString("v", v.getText().toString());
        outState.putString("d", d.getText().toString());

        Toast msg = Toast.makeText(getApplicationContext(),
                "Values are now Saved!!!", Toast.LENGTH_SHORT);
        msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);
        msg.show();*/
        addText("Debug", "onSaveIS");
    }

    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
       /* if(savedInstanceState!=null){
            v.setText(savedInstanceState.getString("v"));
            d.setText(savedInstanceState.getString("d"));
        }
        Toast msg = Toast.makeText(getApplicationContext(),
                "Values are now Restored!!!", Toast.LENGTH_SHORT);
        msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);
        msg.show();*/
        addText("Debug", "onRestoreIS");
    }

    public void onClick(View v){
        switch(v.getId()){
            case R.id.button:{
                counter+=1;
                refreshCounter();
                addText("Debug", "Button Pressed");
                break;
            }case R.id.buttonExit:{
                this.finish();
                saveSharedPrefs(this.v.getText().toString(), "data");
                saveSharedPrefs(counter, "counter");
                /* Αυτος ο τρόπος σκοτώνει την εφαεμογή με μη φυσιολογικό τρόπο και οι μέθοδοι
                 *   που καλούνται φυσιολογικά με την finsish δεν θα καλεστούν. Για αυτό προσθέτουμε
                 *   τις παραπάνω 2 κλήσεις.
                */
                System.exit(0);
                break;
            }
        }

    }

    void refreshCounter(){
        this.v.setText("The button was pressed " + counter + " times");
    }

    @Override
    protected void onStop() {
        super.onStop();
        addText("Debug", "onStop");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        addText("Debug", "onDestroy");
    }

    @Override
    protected void onPause() {
        super.onPause();
        addText("Debug", "onPause");
        saveSharedPrefs(v.getText().toString(), "data");
        saveSharedPrefs(counter,"counter");
    }

    @Override
    protected void onResume() {
        super.onResume();
        addText("Debug", "onResume");
        v.setText(loadSharedPrefsString("data"));
        counter =loadSharedPrefsInt("counter");
        refreshCounter();
    }

    @Override
    protected void onStart() {
        super.onStart();
        addText("Debug", "onStart");
    }

    private void addText(String title, String text){
        statecounter+=1;
        Log.d(title,text);
        d.append(statecounter+":" + text + "\n");
        StateHolder.setData(statecounter + ":" + text + "\n");
        s.setText(StateHolder.getData());
    }

    public static final String PREFS_NAME ="MyPrefsFile";
    public void saveSharedPrefs(String data, String key){
        //SharedPreferences preferences = getSharedPreferences(PREFS_NAME,0);
        SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(this.getApplicationContext());
        SharedPreferences.Editor editor = preferences.edit();
        editor.putString(key,data);
        editor.commit();
    }

    public void saveSharedPrefs(int data, String key){
        //SharedPreferences preferences = getSharedPreferences(PREFS_NAME,0);
        SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(this.getApplicationContext());
        SharedPreferences.Editor editor = preferences.edit();
        editor.putInt(key, data);
        editor.commit();
    }
    public String loadSharedPrefsString(String key){
        SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(this.getApplicationContext());
        return preferences.getString(key,"NO DATA STORED");
    }
    public int loadSharedPrefsInt(String key){
        SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(this.getApplicationContext());
        return preferences.getInt(key,0);
    }
}
